## mingw-w64-mdds-2.1.1-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
cmake_policy(SET CMP0048 NEW)

project(mdds VERSION 2.1.1 LANGUAGES CXX)
set(API_VERSION 2.1)
set(CMAKE_CXX_STANDARD 17)

find_package(Boost)
find_package(Threads)

enable_testing()
set(CMAKE_CTEST_COMMAND ctest -V)

message(STATUS "size of void pointer: ${CMAKE_SIZEOF_VOID_P}")

add_compile_definitions(
    MDDS_UNIT_TEST
    MDDS_DEBUG_NODE_BASE
    SIZEOF_VOID_P=${CMAKE_SIZEOF_VOID_P}
)

if(MSVC)
    add_definitions(/wd4251 /wd4275 /wd4244 /MP)
endif(MSVC)

include_directories(
    ${PROJECT_SOURCE_DIR}/include
    ${Boost_INCLUDE_DIR}
)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

install(DIRECTORY
    ${PROJECT_SOURCE_DIR}/include/mdds
    DESTINATION include/mdds-${API_VERSION}
    FILES_MATCHING
        PATTERN "*.hpp"
        PATTERN "*.inl"
)

add_subdirectory(test)
add_subdirectory(tools)

=== tools/CMakeLists.txt ===

add_subdirectory(runtime-env)

=== test/flat_segment_tree/CMakeLists.txt ===

add_executable(flat-segment-tree-test-main EXCLUDE_FROM_ALL
    test_main.cpp
)

target_link_libraries(flat-segment-tree-test-main PRIVATE test-global)

add_test(flat-segment-tree-test-main flat-segment-tree-test-main)

add_dependencies(check
    flat-segment-tree-test-main
)

=== test/rtree/CMakeLists.txt ===

add_executable(rtree-test EXCLUDE_FROM_ALL
    test_basic.cpp
    test_copy.cpp
    test_directory_node_split.cpp
    test_erase_directories.cpp
    test_exact_search_by_extent.cpp
    test_exact_search_by_point.cpp
    test_forced_reinsertion.cpp
    test_geometry.cpp
    test_intersection.cpp
    test_main.cpp
    test_main.cpp
    test_move.cpp
    test_node_split.cpp
    test_point_objects.cpp
    test_square_distance.cpp
)

target_link_libraries(rtree-test PRIVATE test-global)

add_executable(rtree-test-bulkload EXCLUDE_FROM_ALL
    test_bulkload_main.cpp
)

target_link_libraries(rtree-test-bulkload PRIVATE test-global)

add_test(rtree-test rtree-test)
add_test(rtree-test-bulkload rtree-test-bulkload)

add_dependencies(check
    rtree-test
    rtree-test-bulkload
)

=== test/segment_tree/CMakeLists.txt ===

add_executable(segment-tree-test-main EXCLUDE_FROM_ALL
    test_main.cpp
)

target_link_libraries(segment-tree-test-main PRIVATE test-global)

add_test(segment-tree-test-main segment-tree-test-main)

add_dependencies(check
    segment-tree-test-main
)

=== test/trie_map/CMakeLists.txt ===

add_executable(trie-map-test-main EXCLUDE_FROM_ALL
    test_main.cpp
)

target_link_libraries(trie-map-test-main PRIVATE test-global)

add_test(trie-map-test-main trie-map-test-main)

add_dependencies(check
    trie-map-test-main
)

=== test/multi_type_vector/collection/CMakeLists.txt ===

add_subdirectory(aos)
add_subdirectory(soa)

=== test/multi_type_vector/debug-util/CMakeLists.txt ===

add_subdirectory(soa)

=== test/multi_type_vector/perf/CMakeLists.txt ===
set(TEST_NAME multi-type-vector-test-perf)
set(TARGET_NAME ${TEST_NAME})

add_executable(${TARGET_NAME} EXCLUDE_FROM_ALL
    test_main.cpp
)

target_link_libraries(${TARGET_NAME} PUBLIC test-global)

=== test/multi_type_vector/custom/aos/CMakeLists.txt ===
set(TEST_NAME multi-type-vector-test-custom-aos)
set(TARGET_NAME ${TEST_NAME})

add_executable(${TARGET_NAME} EXCLUDE_FROM_ALL
    test_basic.cpp
    test_main.cpp
    test_managed_block.cpp
    test_misc.cpp
    test_swap.cpp
    test_transfer.cpp
)

target_link_libraries(${TARGET_NAME} PUBLIC test-global)
target_include_directories(${TARGET_NAME} PUBLIC
    ..
    ../tc
    ../../../include
)

add_test(${TEST_NAME} ${TARGET_NAME})
add_dependencies(check ${TARGET_NAME})

=== test/multi_type_vector/custom/soa/CMakeLists.txt ===
set(TEST_NAME multi-type-vector-test-custom-soa)
set(TARGET_NAME ${TEST_NAME})

add_executable(${TARGET_NAME} EXCLUDE_FROM_ALL
    test_basic.cpp
    test_main.cpp
    test_managed_block.cpp
    test_misc.cpp
    test_swap.cpp
    test_transfer.cpp
)

target_link_libraries(${TARGET_NAME} PUBLIC test-global)
target_include_directories(${TARGET_NAME} PUBLIC
    ..
    ../tc
    ../../../include
)

add_test(${TEST_NAME} ${TARGET_NAME})
add_dependencies(check ${TARGET_NAME})

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=mdds
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.1.1
pkgrel=1
pkgdesc="A collection of Multi-Dimensional Data Structure and indexing algorithm. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://gitlab.com/mdds/mdds'
msys2_references=(
  'archlinux: mdds'
)
license=('spdx:MIT')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-autotools")
checkdepends=("${MINGW_PACKAGE_PREFIX}-boost")
source=("https://gitlab.com/mdds/mdds/-/archive/${pkgver}/${_realname}-${pkgver}.tar.bz2")
sha256sums=('06fecb705276a8628e527311cb590c203442f5cbe934d245626cb328458e0e17')

prepare() {
  cd ${_realname}-${pkgver}

  autoreconf -fiv
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  ../${_realname}-${pkgver}/configure \
      --prefix=${MINGW_PREFIX}

  make
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  make check
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" make install

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
